<?php
/****** Create a clickable link
******* $linkname = name of your link (no colors supported),
******* $linktext = text of your popup-box
******/
function makelink($linkname,$linktext) {
	return "<a href=\"text://".strtr($linktext,array("\""=>"'"))."\">".$linkname."</a>";
}
/****** Beautify the output! This produces a 3-way-colorfading:
******* $c1 are the rgb-value from which to fade
******* $c2 are the target rgb-values
******* after $c2 the function will fade back to $c1
******* ..errm.. this is untested for anything else than $c1=array(200,10,200) , $c2=array(220,240,200)
******* Idea: IGN-Bot http://monkerud.com
******/
function colortext($txt,$c1=false,$c2=false) {
	global $BotColors;
	if ($c1==false||$c2==false) {
		if ($BotColors[0]&&$BotColors[1]) {
			$c1=$BotColors[0];
			$c2=$BotColors[1];
		} else {
			$c1=array(200,10,200);
			$c2=array(200,240,200);
		}
	}
	$l=strlen($txt);
	$out="";
	$cx=array( ($c2[0]-$c1[0])/($l/2), ($c2[1]-$c1[1])/($l/2), ($c2[2]-$c1[2])/($l/2) );
	$tagopen=false;
	for ($p=0;$p<$l;$p++) {
		$c1[0]+=$cx[0]; $c1[1]+=$cx[1]; $c1[2]+=$cx[2];
		if ($p==ceil($l/2)-1) {
			$cx[0]*=-1; $cx[1]*=-1; $cx[2]*=-1;
		}
		if (substr($txt,$p,1)=="<") {
			$fontcolor=dec2hex($c1[0]).dec2hex($c1[1]).dec2hex($c1[2]);
			$out.="<font color=#$fontcolor>".substr($txt,$p,1);
			$tagopen=true;
		} elseif (substr($txt,$p,1)==">") {
			$tagopen=false;
			$out.=substr($txt,$p,1)."</font>";
		} elseif (!$tagopen) {
			$fontcolor=dec2hex($c1[0]).dec2hex($c1[1]).dec2hex($c1[2]);
			$out.="<font color=#$fontcolor>".substr($txt,$p,1)."</font>";
		} else {
			$out.= substr($txt,$p,1);
		}
	}
	return $out;
}
/****** 
******* we need a dechex() that returns a stringlength of 2 bytes..
******/
function dec2hex($n) {
	if ($n<16) 
		return "0".dechex($n);
	else
		return dechex($n);
}		
/****** cleanup a message
******* Idea: Beaker, http://tera.kuren.org/basicbot
******/
$stripcolorsarray=array();
for ($i=1;$i<=31;$i++) $stripcolorsarray[$i]="";
function stripcolors($message) {
	global $stripcolorsarray;
	return strtr($message,$stripcolorsarray);
}
/****** Translates a classnumber to its name
******* Thanks: Vhab, http://vhabion.net
******/
function classname($classnumber) {
	switch($classnumber) {
		case 18: return "Barbarian";
		case 19: return "Barbarian"; #female
		case 20: return "Guardian";
		case 21: return "Guardian"; #female
		case 22: return "Conqueror";
		case 23: return "Conqueror"; #female
		case 24: return "Priest of Mitra";
		case 25: return "Priest of Mitra"; #female
		case 26: return "Scoin of Set";
		case 27: return "Scoin of Set"; #female
		case 28: return "Tempest of Set";
		case 29: return "Bear Shaman";
		case 30: return "Bear Shaman"; #female
		case 31: return "Dark Templar";
		case 32: return "Dark Templar"; #female
		case 34: return "Assassin";
		case 35: return "Assassin"; #female
		case 39: return "Ranger";
		case 40: return "Ranger"; #female
		case 41: return "Necromancer";
		case 42: return "Lich";
		case 43: return "Herald of Xolti";
		case 44: return "Demonologist";
		default: return "Unknown(".$classnumber.")";
	}
}
/****** Code: Angels
******* http://boards.hackersquest.org/viewtopic.php?t=5084
******* Function: convert multiple links within a message to a mulitdimensional array
******/
function multilinkstoarray($input) 
{ 
	#remove linebreaks (preg_match will also work when you comment this one)
	$input = eregi_replace("(\n|\r)","",$input); 

	#regextract links into an array 
	preg_match_all("'<a href=(?:\'|\")([a-zA-Z]+)://([0-9]+)/([0-9]+)/((?:[^>])*?)(?:\'|\")>([^<]+)?</a>'i", $input, $out); 
	#Do some array re-formating here, so that every single link gets into its own array dimension. 
	#You may want to delete the following lines if you are satisfied with the $out(put) of the above regex ^^ 
	for($i=0;$i<count($out[0]);$i++) { 
		/* Assign different Arraynames to the different reftypes */ 
		switch ($out[1][$i]) : 
		case 'itemref': 
			$an = array('reftype','lowid','highid','ql','text'); 
		break; 
		case 'charref': 
		default: 
			$an = array('reftype','type','instance','description','text'); 
		break; 
		endswitch; 

		/* Reformat */ 
		$output[$i][$an[0]] = $out[1][$i]; 
		$output[$i][$an[1]] = $out[2][$i]; 
		$output[$i][$an[2]] = $out[3][$i]; 
		$output[$i][$an[3]] = $out[4][$i]; 
		$output[$i][$an[4]] = $out[5][$i];    
		say("Found item!");
		var_dump($output[$i]);
	} 
	return  $output; 
}


?>