<?php
global $KoS,$DataDir;
if (!isset($KoS)) {
	say ("KoS :: loading");
	if (!file_exists($DataDir."/basickos")) mkdir($DataDir."/basickos");
	$KoS=array();
	$kosdir=@opendir($DataDir."/basickos");
	while (false !== ($filename = readdir($kosdir))) {
		if ($filename!="."&&$filename!="..") {
			$f1=fopen($DataDir."/basickos/".$filename,"r");
			if ($f1) {
				$b=fread($f1,64);
				fclose($f1);
				say ("KoS :: loaded $filename, added by $b",1);
				$KoS[$filename]=array();
				$KoS[$filename]["time"]=filemtime($DataDir."/basickos/".$filename);
				$KoS[$filename]["author"]=$b;
			} else {
				say ("KoS :: corrupted file ".$DataDir."/basickos/".$filename."!",1);
			}
		}
	}
	@closedir($kosdir);	
}

if ($pluginwords[1]=="!kos" && $pluginwords[2]=="add")
{	#add to kos
	if ($pluginwords[3]!="")
	{
		$kos=strtoupper(substr($pluginwords[3],0,1)).strtolower(substr($pluginwords[3],1));
		if (!isset($KoS[$kos])) {
			if ($f1=fopen($DataDir."/basickos/".$kos,"w+")) 
			if (fwrite($f1,$sender))
			{
				$KoS[$kos]["author"]=$sender;
				$KoS[$kos]["time"]=time();
				send_reply(colortext(":: $kos is now listed, thx ::"));
			} else {
				send_reply(colortext(":: Cannot save, contact botadmin ::"));
				say(":: KoS :: Error writing $DataDir/basickos/$kos",1);
			}
		} else {
			#add-char already on kos list
			send_reply(colortext(":: $kos is listed since ".strftime("%c",$KoS[$kos]["time"])." ::"));
		}
	} else {
		#bad param for !kos add
		send_reply(colortext(":: Use !kos add (charactername) ::"));
	}
}
elseif ($pluginwords[1]=="!kos" && $pluginwords[2]=="del")
{	#del from kos
	if ($pluginwords!="")
	{
		$kos=strtoupper(substr($pluginwords[3],0,1)).strtolower(substr($pluginwords[3],1));
		if (isset($KoS[$kos])) {
			if (unlink($DataDir."/basickos/".$kos))
			{
				unset($KoS[$kos]);
				send_reply(colortext(":: $kos was removed and is no longer listed ::"));
			} else {
				send_reply(colortext(":: Cannot remove, contact botadmin ::"));
				say(":: KoS :: Error removing $DataDir/basickos/$kos",1);
			}
		} else {
			#del-char not on kos list
			send_reply(":: $kos is not listed ::");
		}
	} else {
		#bad param for !kos del
		send_reply(colortext(":: Use !kos del (charactername) ::"));
	}
}
elseif ($pluginwords[1]=="!kos" && $pluginwords[2]=="list")
{	#list kos
	if (count($KoS)>0) 
	{
		$header=colortext("::::: Kill on sight :::::\n\n\n<font color=F02020>");
		$msg=colortext(":: KoS ::");
		$link="";
		$page=1;
		$n=0;
		foreach ($KoS as $name=>$kos)
		{
			$link.=" ".$name." <font color=10E0A0>since</font> ".strftime("%c",$kos["time"])." <font color=10E0A0>by</font> ".$kos["author"]."\n";
			if (++$n>20)
			{
				$msg.=" ".makelink("Page $page",$header.$link);
				$page++;
				$link="";
				$n=0;
			}			
		}
		if ($n>0) 
		{
			$msg.=" ".makelink("Page $page",$header.$link);
		}
		send_reply($msg);
	} else {
		#kos list empty
		send_reply(colortext(":: Kill on sight list is empty. ::"));
	}
}
elseif ($pluginwords[1]=="!kos" && $pluginwords[2]!="")
{	#search kos
	$search=strtoupper(substr($pluginwords[2],0,1)).strtolower(substr($pluginwords[2],1));
	$N=array();
	foreach ($KoS as $name=>$kos)
	{
		similar_text($name,$search,$p);
		if ($p>66) #must match at least 66%
		{
			$N[$name]=$kos;
		}
	}
	if (count($N)>20)
	{
		send_reply(colortext(":: Be more specific ::"));
	} elseif (count($N)>0) {
		$link=colortext("::::: Kill on sight :::::\n\n\n<font color=F02020>");
		$msg=colortext(":: KoS ::");
		foreach ($N as $name=>$kos)
		{
			$link.=" ".$name." <font color=10E0A0>since</font> ".strftime("%c",$kos["time"])." <font color=10E0A0>by</font> ".$kos["author"]."\n";
		}
		$msg.=" ".makelink("Search result",$header.$link);
		send_reply($msg);
	} else {
		send_reply(colortext(":: Nothing found ::"));
	}
}
elseif ($pluginwords[1]=="!kos")
{	#help
		$link=
			colortext("::::: Kill on sight :::::\n\n\n").
			"Usage:\n".
			" <font color=10E0A0>!kos add (character)</font> - adds a character to the KoS list\n".
			" <font color=10E0A0>!kos del (character)</font> - delete a character from the KoS list\n".
			" <font color=10E0A0>!kos character)</font> - search for characters (similiar spelling)\n".
			" <font color=10E0A0>!kos list</font> - prints the complete KoS list\n".
			"\n".
			" <font color=10E0A0>!kos</font> - prints this help\n"
			;
		$msg=colortext(":: KoS ::");
		$msg.=" ".makelink("click here for help",$header.$link);
		send_reply($msg);
}

?>